/*----- PROTECTED REGION ID(DataVampireClass.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        DataVampireClass.cpp
//
// description : C++ source for the DataVampireClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the DataVampire once per process.
//
// project :     DataVampire
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "DataVampireClass.h"
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	DataVampireClass.cpp

//-------------------------------------------------------------------
/**
 *	Create DataVampireClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_DataVampire_class(const char *name) {
		return DataVampire_ns::DataVampireClass::init(name);
	}
}

namespace DataVampire_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
DataVampireClass *DataVampireClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		DataVampireClass::DataVampireClass(string &s)
 * description : 	constructor for the DataVampireClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
DataVampireClass::DataVampireClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering DataVampireClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(DataVampireClass::constructor) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	DataVampireClass::constructor

	cout2 << "Leaving DataVampireClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		DataVampireClass::~DataVampireClass()
 * description : 	destructor for the DataVampireClass
 */
//--------------------------------------------------------
DataVampireClass::~DataVampireClass()
{
	/*----- PROTECTED REGION ID(DataVampireClass::destructor) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	DataVampireClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		DataVampireClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
DataVampireClass *DataVampireClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new DataVampireClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		DataVampireClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
DataVampireClass *DataVampireClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		GetSumClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetSumClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GetSumClass::execute(): arrived" << endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	return insert((static_cast<DataVampire *>(device))->get_sum(argin));
}

//--------------------------------------------------------
/**
 * method : 		GetMeanClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetMeanClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GetMeanClass::execute(): arrived" << endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	return insert((static_cast<DataVampire *>(device))->get_mean(argin));
}

//--------------------------------------------------------
/**
 * method : 		GetHorPosClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetHorPosClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GetHorPosClass::execute(): arrived" << endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	return insert((static_cast<DataVampire *>(device))->get_hor_pos(argin));
}

//--------------------------------------------------------
/**
 * method : 		GetVerPosClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetVerPosClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GetVerPosClass::execute(): arrived" << endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	return insert((static_cast<DataVampire *>(device))->get_ver_pos(argin));
}

//--------------------------------------------------------
/**
 * method : 		GetHorSigmaClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetHorSigmaClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GetHorSigmaClass::execute(): arrived" << endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	return insert((static_cast<DataVampire *>(device))->get_hor_sigma(argin));
}

//--------------------------------------------------------
/**
 * method : 		GetVerSigmaClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetVerSigmaClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GetVerSigmaClass::execute(): arrived" << endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	return insert((static_cast<DataVampire *>(device))->get_ver_sigma(argin));
}

//--------------------------------------------------------
/**
 * method : 		GetValidValuesClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetValidValuesClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GetValidValuesClass::execute(): arrived" << endl;
	const Tango::DevVarLongArray *argin;
	extract(in_any, argin);
	return insert((static_cast<DataVampire *>(device))->get_valid_values(argin));
}

//--------------------------------------------------------
/**
 * method : 		SetBackgroundClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SetBackgroundClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SetBackgroundClass::execute(): arrived" << endl;
	((static_cast<DataVampire *>(device))->set_background());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : DataVampireClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum DataVampireClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : DataVampireClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum DataVampireClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : DataVampireClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum DataVampireClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : DataVampireClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void DataVampireClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "HorCalib";
	prop_desc = "";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "VerCalib";
	prop_desc = "";
	prop_def  = "1";
	vect_data.clear();
	vect_data.push_back("1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "RoiParam";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CommandString";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : DataVampireClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void DataVampireClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("DataVampire");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Get vectors of 1D or 2D data and calculate sum, mean, horpos, verpos, horsigma, versigma, numsamples");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : DataVampireClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void DataVampireClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(DataVampireClass::device_factory_before) ENABLED START -----*/
/* clang-format on */
//	Add your own code
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	DataVampireClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new DataVampire(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		DataVampire *dev = static_cast<DataVampire *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(DataVampireClass::device_factory_after) ENABLED START -----*/
/* clang-format on */
//	Add your own code
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	DataVampireClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : DataVampireClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void DataVampireClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(DataVampireClass::attribute_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	DataVampireClass::attribute_factory_before
	//	Attribute : MinThreshold
	MinThresholdAttrib	*minthreshold = new MinThresholdAttrib();
	Tango::UserDefaultAttrProp	minthreshold_prop;
	//	description	not set for MinThreshold
	//	label	not set for MinThreshold
	//	unit	not set for MinThreshold
	//	standard_unit	not set for MinThreshold
	//	display_unit	not set for MinThreshold
	minthreshold_prop.set_format("%.5f");
	minthreshold_prop.set_max_value("9.99e10");
	minthreshold_prop.set_min_value("-9.99e10");
	//	max_alarm	not set for MinThreshold
	//	min_alarm	not set for MinThreshold
	//	max_warning	not set for MinThreshold
	//	min_warning	not set for MinThreshold
	//	delta_t	not set for MinThreshold
	//	delta_val	not set for MinThreshold
	
	minthreshold->set_default_properties(minthreshold_prop);
	//	Not Polled
	minthreshold->set_disp_level(Tango::OPERATOR);
	minthreshold->set_memorized();
	minthreshold->set_memorized_init(true);
	att_list.push_back(minthreshold);

	//	Attribute : MaxThreshold
	MaxThresholdAttrib	*maxthreshold = new MaxThresholdAttrib();
	Tango::UserDefaultAttrProp	maxthreshold_prop;
	//	description	not set for MaxThreshold
	//	label	not set for MaxThreshold
	//	unit	not set for MaxThreshold
	//	standard_unit	not set for MaxThreshold
	//	display_unit	not set for MaxThreshold
	maxthreshold_prop.set_format("%.5f");
	maxthreshold_prop.set_max_value("9.99e10");
	maxthreshold_prop.set_min_value("-9.99e10");
	//	max_alarm	not set for MaxThreshold
	//	min_alarm	not set for MaxThreshold
	//	max_warning	not set for MaxThreshold
	//	min_warning	not set for MaxThreshold
	//	delta_t	not set for MaxThreshold
	//	delta_val	not set for MaxThreshold
	
	maxthreshold->set_default_properties(maxthreshold_prop);
	//	Not Polled
	maxthreshold->set_disp_level(Tango::OPERATOR);
	maxthreshold->set_memorized();
	maxthreshold->set_memorized_init(true);
	att_list.push_back(maxthreshold);

	//	Attribute : CommandString
	CommandStringAttrib	*commandstring = new CommandStringAttrib();
	Tango::UserDefaultAttrProp	commandstring_prop;
	//	description	not set for CommandString
	//	label	not set for CommandString
	//	unit	not set for CommandString
	//	standard_unit	not set for CommandString
	//	display_unit	not set for CommandString
	//	format	not set for CommandString
	//	max_value	not set for CommandString
	//	min_value	not set for CommandString
	//	max_alarm	not set for CommandString
	//	min_alarm	not set for CommandString
	//	max_warning	not set for CommandString
	//	min_warning	not set for CommandString
	//	delta_t	not set for CommandString
	//	delta_val	not set for CommandString
	
	commandstring->set_default_properties(commandstring_prop);
	//	Not Polled
	commandstring->set_disp_level(Tango::OPERATOR);
	commandstring->set_memorized();
	commandstring->set_memorized_init(true);
	att_list.push_back(commandstring);

	//	Attribute : PollingTime
	PollingTimeAttrib	*pollingtime = new PollingTimeAttrib();
	Tango::UserDefaultAttrProp	pollingtime_prop;
	pollingtime_prop.set_description("-1: disabled");
	//	label	not set for PollingTime
	pollingtime_prop.set_unit("ms");
	//	standard_unit	not set for PollingTime
	pollingtime_prop.set_display_unit("ms");
	pollingtime_prop.set_format("%d");
	pollingtime_prop.set_max_value("100000");
	pollingtime_prop.set_min_value("-1");
	//	max_alarm	not set for PollingTime
	//	min_alarm	not set for PollingTime
	//	max_warning	not set for PollingTime
	//	min_warning	not set for PollingTime
	//	delta_t	not set for PollingTime
	//	delta_val	not set for PollingTime
	
	pollingtime->set_default_properties(pollingtime_prop);
	//	Not Polled
	pollingtime->set_disp_level(Tango::OPERATOR);
	pollingtime->set_memorized();
	pollingtime->set_memorized_init(true);
	att_list.push_back(pollingtime);

	//	Attribute : PollingSamples
	PollingSamplesAttrib	*pollingsamples = new PollingSamplesAttrib();
	Tango::UserDefaultAttrProp	pollingsamples_prop;
	pollingsamples_prop.set_description("-1: disabled");
	//	label	not set for PollingSamples
	//	unit	not set for PollingSamples
	//	standard_unit	not set for PollingSamples
	//	display_unit	not set for PollingSamples
	//	format	not set for PollingSamples
	pollingsamples_prop.set_max_value("1000000");
	pollingsamples_prop.set_min_value("-1000000");
	//	max_alarm	not set for PollingSamples
	//	min_alarm	not set for PollingSamples
	//	max_warning	not set for PollingSamples
	//	min_warning	not set for PollingSamples
	//	delta_t	not set for PollingSamples
	//	delta_val	not set for PollingSamples
	
	pollingsamples->set_default_properties(pollingsamples_prop);
	//	Not Polled
	pollingsamples->set_disp_level(Tango::OPERATOR);
	pollingsamples->set_memorized();
	pollingsamples->set_memorized_init(true);
	att_list.push_back(pollingsamples);

	//	Attribute : Sum
	SumAttrib	*sum = new SumAttrib();
	Tango::UserDefaultAttrProp	sum_prop;
	//	description	not set for Sum
	//	label	not set for Sum
	//	unit	not set for Sum
	//	standard_unit	not set for Sum
	//	display_unit	not set for Sum
	sum_prop.set_format("%.5f");
	sum_prop.set_max_value("9999999999");
	sum_prop.set_min_value("-9999999999");
	//	max_alarm	not set for Sum
	//	min_alarm	not set for Sum
	//	max_warning	not set for Sum
	//	min_warning	not set for Sum
	//	delta_t	not set for Sum
	//	delta_val	not set for Sum
	
	sum->set_default_properties(sum_prop);
	//	Not Polled
	sum->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(sum);

	//	Attribute : Mean
	MeanAttrib	*mean = new MeanAttrib();
	Tango::UserDefaultAttrProp	mean_prop;
	//	description	not set for Mean
	//	label	not set for Mean
	//	unit	not set for Mean
	//	standard_unit	not set for Mean
	//	display_unit	not set for Mean
	mean_prop.set_format("%.5f");
	mean_prop.set_max_value("9999999999");
	mean_prop.set_min_value("-9999999999");
	//	max_alarm	not set for Mean
	//	min_alarm	not set for Mean
	//	max_warning	not set for Mean
	//	min_warning	not set for Mean
	//	delta_t	not set for Mean
	//	delta_val	not set for Mean
	
	mean->set_default_properties(mean_prop);
	//	Not Polled
	mean->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(mean);

	//	Attribute : HorPos
	HorPosAttrib	*horpos = new HorPosAttrib();
	Tango::UserDefaultAttrProp	horpos_prop;
	//	description	not set for HorPos
	//	label	not set for HorPos
	//	unit	not set for HorPos
	//	standard_unit	not set for HorPos
	//	display_unit	not set for HorPos
	horpos_prop.set_format("%.5f");
	horpos_prop.set_max_value("9999999999");
	horpos_prop.set_min_value("-9999999999");
	//	max_alarm	not set for HorPos
	//	min_alarm	not set for HorPos
	//	max_warning	not set for HorPos
	//	min_warning	not set for HorPos
	//	delta_t	not set for HorPos
	//	delta_val	not set for HorPos
	
	horpos->set_default_properties(horpos_prop);
	//	Not Polled
	horpos->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(horpos);

	//	Attribute : VerPos
	VerPosAttrib	*verpos = new VerPosAttrib();
	Tango::UserDefaultAttrProp	verpos_prop;
	//	description	not set for VerPos
	//	label	not set for VerPos
	//	unit	not set for VerPos
	//	standard_unit	not set for VerPos
	//	display_unit	not set for VerPos
	verpos_prop.set_format("%.5f");
	verpos_prop.set_max_value("9999999999");
	verpos_prop.set_min_value("-9999999999");
	//	max_alarm	not set for VerPos
	//	min_alarm	not set for VerPos
	//	max_warning	not set for VerPos
	//	min_warning	not set for VerPos
	//	delta_t	not set for VerPos
	//	delta_val	not set for VerPos
	
	verpos->set_default_properties(verpos_prop);
	//	Not Polled
	verpos->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(verpos);

	//	Attribute : HorSigma
	HorSigmaAttrib	*horsigma = new HorSigmaAttrib();
	Tango::UserDefaultAttrProp	horsigma_prop;
	//	description	not set for HorSigma
	//	label	not set for HorSigma
	//	unit	not set for HorSigma
	//	standard_unit	not set for HorSigma
	//	display_unit	not set for HorSigma
	horsigma_prop.set_format("%.5f");
	horsigma_prop.set_max_value("9999999999");
	horsigma_prop.set_min_value("-9999999999");
	//	max_alarm	not set for HorSigma
	//	min_alarm	not set for HorSigma
	//	max_warning	not set for HorSigma
	//	min_warning	not set for HorSigma
	//	delta_t	not set for HorSigma
	//	delta_val	not set for HorSigma
	
	horsigma->set_default_properties(horsigma_prop);
	//	Not Polled
	horsigma->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(horsigma);

	//	Attribute : VerSigma
	VerSigmaAttrib	*versigma = new VerSigmaAttrib();
	Tango::UserDefaultAttrProp	versigma_prop;
	//	description	not set for VerSigma
	//	label	not set for VerSigma
	//	unit	not set for VerSigma
	//	standard_unit	not set for VerSigma
	//	display_unit	not set for VerSigma
	versigma_prop.set_format("%.5f");
	versigma_prop.set_max_value("9999999999");
	versigma_prop.set_min_value("-9999999999");
	//	max_alarm	not set for VerSigma
	//	min_alarm	not set for VerSigma
	//	max_warning	not set for VerSigma
	//	min_warning	not set for VerSigma
	//	delta_t	not set for VerSigma
	//	delta_val	not set for VerSigma
	
	versigma->set_default_properties(versigma_prop);
	//	Not Polled
	versigma->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(versigma);

	//	Attribute : ValidValues
	ValidValuesAttrib	*validvalues = new ValidValuesAttrib();
	Tango::UserDefaultAttrProp	validvalues_prop;
	//	description	not set for ValidValues
	//	label	not set for ValidValues
	//	unit	not set for ValidValues
	//	standard_unit	not set for ValidValues
	//	display_unit	not set for ValidValues
	validvalues_prop.set_format("%d");
	validvalues_prop.set_max_value("99999999");
	validvalues_prop.set_min_value("0");
	//	max_alarm	not set for ValidValues
	//	min_alarm	not set for ValidValues
	//	max_warning	not set for ValidValues
	//	min_warning	not set for ValidValues
	//	delta_t	not set for ValidValues
	//	delta_val	not set for ValidValues
	
	validvalues->set_default_properties(validvalues_prop);
	//	Not Polled
	validvalues->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(validvalues);

	//	Attribute : Enable
	EnableAttrib	*enable = new EnableAttrib();
	Tango::UserDefaultAttrProp	enable_prop;
	//	description	not set for Enable
	//	label	not set for Enable
	//	unit	not set for Enable
	//	standard_unit	not set for Enable
	//	display_unit	not set for Enable
	//	format	not set for Enable
	//	max_value	not set for Enable
	//	min_value	not set for Enable
	//	max_alarm	not set for Enable
	//	min_alarm	not set for Enable
	//	max_warning	not set for Enable
	//	min_warning	not set for Enable
	//	delta_t	not set for Enable
	//	delta_val	not set for Enable
	
	enable->set_default_properties(enable_prop);
	//	Not Polled
	enable->set_disp_level(Tango::OPERATOR);
	enable->set_memorized();
	enable->set_memorized_init(true);
	att_list.push_back(enable);

	//	Attribute : CacheSize
	CacheSizeAttrib	*cachesize = new CacheSizeAttrib();
	Tango::UserDefaultAttrProp	cachesize_prop;
	//	description	not set for CacheSize
	//	label	not set for CacheSize
	//	unit	not set for CacheSize
	//	standard_unit	not set for CacheSize
	//	display_unit	not set for CacheSize
	//	format	not set for CacheSize
	//	max_value	not set for CacheSize
	//	min_value	not set for CacheSize
	//	max_alarm	not set for CacheSize
	//	min_alarm	not set for CacheSize
	//	max_warning	not set for CacheSize
	//	min_warning	not set for CacheSize
	//	delta_t	not set for CacheSize
	//	delta_val	not set for CacheSize
	
	cachesize->set_default_properties(cachesize_prop);
	//	Not Polled
	cachesize->set_disp_level(Tango::OPERATOR);
	cachesize->set_memorized();
	cachesize->set_memorized_init(true);
	att_list.push_back(cachesize);

	//	Attribute : AutoBackgroundSamples
	AutoBackgroundSamplesAttrib	*autobackgroundsamples = new AutoBackgroundSamplesAttrib();
	Tango::UserDefaultAttrProp	autobackgroundsamples_prop;
	autobackgroundsamples_prop.set_description("0 to disable");
	//	label	not set for AutoBackgroundSamples
	//	unit	not set for AutoBackgroundSamples
	//	standard_unit	not set for AutoBackgroundSamples
	//	display_unit	not set for AutoBackgroundSamples
	autobackgroundsamples_prop.set_format("%d");
	autobackgroundsamples_prop.set_max_value("9999");
	autobackgroundsamples_prop.set_min_value("-1");
	//	max_alarm	not set for AutoBackgroundSamples
	//	min_alarm	not set for AutoBackgroundSamples
	//	max_warning	not set for AutoBackgroundSamples
	//	min_warning	not set for AutoBackgroundSamples
	//	delta_t	not set for AutoBackgroundSamples
	//	delta_val	not set for AutoBackgroundSamples
	
	autobackgroundsamples->set_default_properties(autobackgroundsamples_prop);
	//	Not Polled
	autobackgroundsamples->set_disp_level(Tango::OPERATOR);
	autobackgroundsamples->set_memorized();
	autobackgroundsamples->set_memorized_init(true);
	att_list.push_back(autobackgroundsamples);

	//	Attribute : PostAcqRoi
	PostAcqRoiAttrib	*postacqroi = new PostAcqRoiAttrib();
	Tango::UserDefaultAttrProp	postacqroi_prop;
	//	description	not set for PostAcqRoi
	//	label	not set for PostAcqRoi
	//	unit	not set for PostAcqRoi
	//	standard_unit	not set for PostAcqRoi
	//	display_unit	not set for PostAcqRoi
	//	format	not set for PostAcqRoi
	//	max_value	not set for PostAcqRoi
	//	min_value	not set for PostAcqRoi
	//	max_alarm	not set for PostAcqRoi
	//	min_alarm	not set for PostAcqRoi
	//	max_warning	not set for PostAcqRoi
	//	min_warning	not set for PostAcqRoi
	//	delta_t	not set for PostAcqRoi
	//	delta_val	not set for PostAcqRoi
	
	postacqroi->set_default_properties(postacqroi_prop);
	//	Not Polled
	postacqroi->set_disp_level(Tango::OPERATOR);
	postacqroi->set_memorized();
	postacqroi->set_memorized_init(true);
	att_list.push_back(postacqroi);

	//	Attribute : Width
	WidthAttrib	*width = new WidthAttrib();
	Tango::UserDefaultAttrProp	width_prop;
	//	description	not set for Width
	//	label	not set for Width
	//	unit	not set for Width
	//	standard_unit	not set for Width
	//	display_unit	not set for Width
	width_prop.set_format("%d");
	width_prop.set_max_value("9999");
	width_prop.set_min_value("0");
	//	max_alarm	not set for Width
	//	min_alarm	not set for Width
	//	max_warning	not set for Width
	//	min_warning	not set for Width
	//	delta_t	not set for Width
	//	delta_val	not set for Width
	
	width->set_default_properties(width_prop);
	//	Not Polled
	width->set_disp_level(Tango::OPERATOR);
	width->set_memorized();
	width->set_memorized_init(true);
	att_list.push_back(width);

	//	Attribute : Height
	HeightAttrib	*height = new HeightAttrib();
	Tango::UserDefaultAttrProp	height_prop;
	//	description	not set for Height
	//	label	not set for Height
	//	unit	not set for Height
	//	standard_unit	not set for Height
	//	display_unit	not set for Height
	height_prop.set_format("%d");
	height_prop.set_max_value("9999");
	height_prop.set_min_value("0");
	//	max_alarm	not set for Height
	//	min_alarm	not set for Height
	//	max_warning	not set for Height
	//	min_warning	not set for Height
	//	delta_t	not set for Height
	//	delta_val	not set for Height
	
	height->set_default_properties(height_prop);
	//	Not Polled
	height->set_disp_level(Tango::OPERATOR);
	height->set_memorized();
	height->set_memorized_init(true);
	att_list.push_back(height);

	//	Attribute : RoiParam
	RoiParamAttrib	*roiparam = new RoiParamAttrib();
	Tango::UserDefaultAttrProp	roiparam_prop;
	//	description	not set for RoiParam
	//	label	not set for RoiParam
	//	unit	not set for RoiParam
	//	standard_unit	not set for RoiParam
	//	display_unit	not set for RoiParam
	//	format	not set for RoiParam
	//	max_value	not set for RoiParam
	//	min_value	not set for RoiParam
	//	max_alarm	not set for RoiParam
	//	min_alarm	not set for RoiParam
	//	max_warning	not set for RoiParam
	//	min_warning	not set for RoiParam
	//	delta_t	not set for RoiParam
	//	delta_val	not set for RoiParam
	
	roiparam->set_default_properties(roiparam_prop);
	//	Not Polled
	roiparam->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(roiparam);

	//	Attribute : Spectrum
	SpectrumAttrib	*spectrum = new SpectrumAttrib();
	Tango::UserDefaultAttrProp	spectrum_prop;
	//	description	not set for Spectrum
	//	label	not set for Spectrum
	//	unit	not set for Spectrum
	//	standard_unit	not set for Spectrum
	//	display_unit	not set for Spectrum
	//	format	not set for Spectrum
	//	max_value	not set for Spectrum
	//	min_value	not set for Spectrum
	//	max_alarm	not set for Spectrum
	//	min_alarm	not set for Spectrum
	//	max_warning	not set for Spectrum
	//	min_warning	not set for Spectrum
	//	delta_t	not set for Spectrum
	//	delta_val	not set for Spectrum
	
	spectrum->set_default_properties(spectrum_prop);
	//	Not Polled
	spectrum->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(spectrum);

	//	Attribute : HorBackground
	HorBackgroundAttrib	*horbackground = new HorBackgroundAttrib();
	Tango::UserDefaultAttrProp	horbackground_prop;
	//	description	not set for HorBackground
	//	label	not set for HorBackground
	//	unit	not set for HorBackground
	//	standard_unit	not set for HorBackground
	//	display_unit	not set for HorBackground
	//	format	not set for HorBackground
	//	max_value	not set for HorBackground
	//	min_value	not set for HorBackground
	//	max_alarm	not set for HorBackground
	//	min_alarm	not set for HorBackground
	//	max_warning	not set for HorBackground
	//	min_warning	not set for HorBackground
	//	delta_t	not set for HorBackground
	//	delta_val	not set for HorBackground
	
	horbackground->set_default_properties(horbackground_prop);
	//	Not Polled
	horbackground->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(horbackground);

	//	Attribute : VerBackground
	VerBackgroundAttrib	*verbackground = new VerBackgroundAttrib();
	Tango::UserDefaultAttrProp	verbackground_prop;
	//	description	not set for VerBackground
	//	label	not set for VerBackground
	//	unit	not set for VerBackground
	//	standard_unit	not set for VerBackground
	//	display_unit	not set for VerBackground
	//	format	not set for VerBackground
	//	max_value	not set for VerBackground
	//	min_value	not set for VerBackground
	//	max_alarm	not set for VerBackground
	//	min_alarm	not set for VerBackground
	//	max_warning	not set for VerBackground
	//	min_warning	not set for VerBackground
	//	delta_t	not set for VerBackground
	//	delta_val	not set for VerBackground
	
	verbackground->set_default_properties(verbackground_prop);
	//	Not Polled
	verbackground->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(verbackground);

	//	Attribute : Image
	ImageAttrib	*image = new ImageAttrib();
	Tango::UserDefaultAttrProp	image_prop;
	//	description	not set for Image
	//	label	not set for Image
	//	unit	not set for Image
	//	standard_unit	not set for Image
	//	display_unit	not set for Image
	//	format	not set for Image
	//	max_value	not set for Image
	//	min_value	not set for Image
	//	max_alarm	not set for Image
	//	min_alarm	not set for Image
	//	max_warning	not set for Image
	//	min_warning	not set for Image
	//	delta_t	not set for Image
	//	delta_val	not set for Image
	
	image->set_default_properties(image_prop);
	//	Not Polled
	image->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(image);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(DataVampireClass::attribute_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	DataVampireClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : DataVampireClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void DataVampireClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(DataVampireClass::pipe_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	DataVampireClass::pipe_factory_before
	/*----- PROTECTED REGION ID(DataVampireClass::pipe_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	DataVampireClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : DataVampireClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void DataVampireClass::command_factory()
{
	/*----- PROTECTED REGION ID(DataVampireClass::command_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	DataVampireClass::command_factory_before


	//	Command GetSum
	GetSumClass	*pGetSumCmd =
		new GetSumClass("GetSum",
			Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
			"mode,samples; mode,bunch start,bunch end",
			"values",
			Tango::OPERATOR);
	command_list.push_back(pGetSumCmd);

	//	Command GetMean
	GetMeanClass	*pGetMeanCmd =
		new GetMeanClass("GetMean",
			Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
			"mode,samples; mode,bunch start,bunch end",
			"values",
			Tango::OPERATOR);
	command_list.push_back(pGetMeanCmd);

	//	Command GetHorPos
	GetHorPosClass	*pGetHorPosCmd =
		new GetHorPosClass("GetHorPos",
			Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
			"mode,samples; mode,bunch start,bunch end",
			"values",
			Tango::OPERATOR);
	command_list.push_back(pGetHorPosCmd);

	//	Command GetVerPos
	GetVerPosClass	*pGetVerPosCmd =
		new GetVerPosClass("GetVerPos",
			Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
			"mode,samples; mode,bunch start,bunch end",
			"values",
			Tango::OPERATOR);
	command_list.push_back(pGetVerPosCmd);

	//	Command GetHorSigma
	GetHorSigmaClass	*pGetHorSigmaCmd =
		new GetHorSigmaClass("GetHorSigma",
			Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
			"mode,samples; mode,bunch start,bunch end",
			"values",
			Tango::OPERATOR);
	command_list.push_back(pGetHorSigmaCmd);

	//	Command GetVerSigma
	GetVerSigmaClass	*pGetVerSigmaCmd =
		new GetVerSigmaClass("GetVerSigma",
			Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
			"mode,samples; mode,bunch start,bunch end",
			"values",
			Tango::OPERATOR);
	command_list.push_back(pGetVerSigmaCmd);

	//	Command GetValidValues
	GetValidValuesClass	*pGetValidValuesCmd =
		new GetValidValuesClass("GetValidValues",
			Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
			"mode,samples; mode,bunch start,bunch end",
			"values",
			Tango::OPERATOR);
	command_list.push_back(pGetValidValuesCmd);

	//	Command SetBackground
	SetBackgroundClass	*pSetBackgroundCmd =
		new SetBackgroundClass("SetBackground",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pSetBackgroundCmd);

	/*----- PROTECTED REGION ID(DataVampireClass::command_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	DataVampireClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		DataVampireClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void DataVampireClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(DataVampireClass::create_static_att_list) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	DataVampireClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		DataVampireClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void DataVampireClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		DataVampire *dev = static_cast<DataVampire *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(DataVampireClass::erase_dynamic_attributes) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	DataVampireClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : DataVampireClass::get_attr_object_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *DataVampireClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(DataVampireClass::Additional Methods) ENABLED START -----*/
/* clang-format on */
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	DataVampireClass::Additional Methods
} //	namespace
